JUCE: Thread Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Member Functions | List of all members
Thread Class Referenceabstract
juce_core » threads

Encapsulates a thread. More...

`#include <juce_Thread.h>`

Inheritance diagram for Thread:

## Classes
class | Listener
| Used to receive callbacks for thread exit calls. More...
struct | RealtimeOptions
| A selection of options available when creating realtime threads. More...

## Public Types
enum class | Priority { highest = 2 , high = 1 , normal = 0 , low = -1 , background = -2 }
| The different runtime priorities of non-realtime threads. More...
using | ThreadID = void *
| A value type used for thread IDs.

## Public Member Functions
| Thread (const String &threadName, size_t threadStackSize=osDefaultStackSize)
| Creates a thread.
virtual | ~Thread ()
| Destructor.
virtual void | run ()=0
| Must be implemented to perform the thread's actual code.
bool | startThread ()
| Attempts to start a new thread with default ('Priority::normal') priority.
bool | startThread (Priority newPriority)
| Attempts to start a new thread with a given priority.
bool | startRealtimeThread (const RealtimeOptions &options)
| Starts the thread with realtime performance characteristics on platforms that support it.
bool | stopThread (int timeOutMilliseconds)
| Attempts to stop the thread running.
bool | isThreadRunning () const
| Returns true if the thread is currently active.
void | signalThreadShouldExit ()
| Sets a flag to tell the thread it should stop.
bool | threadShouldExit () const
| Checks whether the thread has been told to stop running.
bool | waitForThreadToExit (int timeOutMilliseconds) const
| Waits for the thread to stop.
void | addListener (Listener *)
| Add a listener to this thread which will receive a callback when signalThreadShouldExit was called on this thread.
void | removeListener (Listener *)
| Removes a listener added with addListener.
bool | isRealtime () const
| Returns true if this Thread represents a realtime thread.
void | setAffinityMask (uint32 affinityMask)
| Sets the affinity mask for the thread.
bool | wait (double timeOutMilliseconds) const
| Suspends the execution of this thread until either the specified timeout period has elapsed, or another thread calls the notify() method to wake it up.
void | notify () const
| Wakes up the thread.
ThreadID | getThreadId () const noexcept
| Returns the ID of this thread.
const String & | getThreadName () const noexcept
| Returns the name of the thread.

## Static Public Member Functions
static bool | launch (std::function< void()> functionToRun)
| Invokes a lambda or function on its own thread with the default priority.
static bool | launch (Priority priority, std::function< void()> functionToRun)
| Invokes a lambda or function on its own thread with a custom priority.
static bool | currentThreadShouldExit ()
| Checks whether the current thread has been told to stop running.
static void JUCE_CALLTYPE | setCurrentThreadAffinityMask (uint32 affinityMask)
| Changes the affinity mask for the caller thread.
static void JUCE_CALLTYPE | sleep (int milliseconds)
| Suspends the execution of the current thread until the specified timeout period has elapsed (note that this may not be exact).
static void JUCE_CALLTYPE | yield ()
| Yields the current thread's CPU time-slot and allows a new thread to run.
static ThreadID JUCE_CALLTYPE | getCurrentThreadId ()
| Returns an id that identifies the caller thread.
static Thread *JUCE_CALLTYPE | getCurrentThread ()
| Finds the thread object that is currently running.
static void JUCE_CALLTYPE | setCurrentThreadName (const String &newThreadName)
| Changes the name of the caller thread.
static void | initialiseJUCE (void *jniEnv, void *jContext)
| Initialises the JUCE subsystem for projects not created by the Projucer.

## Static Public Attributes
static constexpr size_t | osDefaultStackSize { 0 }

## Protected Member Functions
Priority | getPriority () const
| Returns the current priority of this thread.
bool | setPriority (Priority newPriority)
| Attempts to set the priority for this thread.

## Detailed Description

Encapsulates a thread.

Subclasses derive from Thread and implement the run() method, in which they do their business. The thread can then be started with the startThread() or startRealtimeThread() methods and controlled with various other methods.

This class also contains some thread-related static methods, such as sleep(), yield(), getCurrentThreadId() etc.

See also
  CriticalSection, WaitableEvent, Process, ThreadWithProgressWindow, MessageManagerLock

## Member Typedef Documentation

## ◆ ThreadID

using Thread::ThreadID = void*

A value type used for thread IDs.

See also
  getCurrentThreadId(), getThreadId()

## Member Enumeration Documentation

## ◆ Priority

enum class Thread::Priority
| strong

The different runtime priorities of non-realtime threads.

See also
  startThread

Enumerator
highest | The highest possible priority that isn't a dedicated realtime thread.
high | Makes use of performance cores and higher clocks.
normal | The OS default. It will balance out across all cores.
low | Uses efficiency cores when possible.
background | Restricted to efficiency cores on platforms that have them.

## Constructor & Destructor Documentation

## ◆ Thread()

Thread::Thread | ( | const String & | threadName,
|  | size_t | threadStackSize = `osDefaultStackSize`
| ) |  |
| explicit

Creates a thread.

When first created, the thread is not running. Use the startThread() method to start it.

Parameters

  threadName | The name of the thread which typically appears in debug logs and profiles.
  threadStackSize | The size of the stack of the thread. If this value is zero then the default stack size of the OS will be used.

## ◆ ~Thread()

virtual Thread::~Thread | ( |  | ) |
| virtual

Destructor.

You must never attempt to delete a Thread object while it's still running - always call stopThread() and make sure your thread has stopped before deleting the object. Failing to do so will throw an assertion, and put you firmly into undefined behaviour territory.

## Member Function Documentation

## ◆ run()

virtual void Thread::run | ( |  | ) |
| pure virtual

Must be implemented to perform the thread's actual code.

Remember that the thread must regularly check the threadShouldExit() method whilst running, and if this returns true it should return from the run() method as soon as possible to avoid being forcibly killed.

See also
  threadShouldExit, startThread

## ◆ startThread() [1/2]

bool Thread::startThread | ( |  | ) |

Attempts to start a new thread with default ('Priority::normal') priority.

This will cause the thread's run() method to be called by a new thread. If this thread is already running, startThread() won't do anything.

If a thread cannot be created with the requested priority, this will return false and Thread::run() will not be called. An exception to this is the Android platform, which always starts a thread and attempts to upgrade the thread after creation.

Returns
  true if the thread started successfully. false if it was unsuccesful.

See also
  stopThread

## ◆ startThread() [2/2]

bool Thread::startThread | ( | Priority | newPriority | ) |

Attempts to start a new thread with a given priority.

This will cause the thread's run() method to be called by a new thread. If this thread is already running, startThread() won't do anything.

If a thread cannot be created with the requested priority, this will return false and Thread::run() will not be called. An exception to this is the Android platform, which always starts a thread and attempts to upgrade the thread after creation.

Parameters

  newPriority | Priority the thread should be assigned. This parameter is ignored on Linux.

Returns
  true if the thread started successfully, false if it was unsuccesful.

See also
  startThread, setPriority, startRealtimeThread

## ◆ startRealtimeThread()

bool Thread::startRealtimeThread | ( | const RealtimeOptions & | options | ) |

Starts the thread with realtime performance characteristics on platforms that support it.

You cannot change the options of a running realtime thread, nor switch a non-realtime thread to a realtime thread. To make these changes you must first stop the thread and then restart with different options.

Parameters

  options | Realtime options the thread should be created with.

See also
  startThread, RealtimeOptions

## ◆ stopThread()

bool Thread::stopThread | ( | int | timeOutMilliseconds | ) |

Attempts to stop the thread running.

This method will cause the threadShouldExit() method to return true and call notify() in case the thread is currently waiting.

Hopefully the thread will then respond to this by exiting cleanly, and the stopThread method will wait for a given time-period for this to happen.

If the thread is stuck and fails to respond after the timeout, it gets forcibly killed, which is a very bad thing to happen, as it could still be holding locks, etc. which are needed by other parts of your program.

Parameters

  timeOutMilliseconds | The number of milliseconds to wait for the thread to finish before killing it by force. A negative value in here will wait forever.

Returns
  true if the thread was cleanly stopped before the timeout, or false if it had to be killed by force.

See also
  signalThreadShouldExit, threadShouldExit, waitForThreadToExit, isThreadRunning

## ◆ launch() [1/2]

static bool Thread::launch | ( | std::function< void()> | functionToRun | ) |
| static

Invokes a lambda or function on its own thread with the default priority.

This will spin up a Thread object which calls the function and then exits. Bear in mind that starting and stopping a thread can be a fairly heavyweight operation, so you might prefer to use a ThreadPool if you're kicking off a lot of short background tasks.

Also note that using an anonymous thread makes it very difficult to interrupt the function when you need to stop it, e.g. when your app quits. So it's up to you to deal with situations where the function may fail to stop in time.

Parameters

  functionToRun | The lambda to be called from the new Thread.

Returns
  true if the thread started successfully, or false if it failed.

See also
  launch.

## ◆ launch() [2/2]

static bool Thread::launch | ( | Priority | priority,
|  | std::function< void()> | functionToRun
| ) |  |
| static

Invokes a lambda or function on its own thread with a custom priority.

This will spin up a Thread object which calls the function and then exits. Bear in mind that starting and stopping a thread can be a fairly heavyweight operation, so you might prefer to use a ThreadPool if you're kicking off a lot of short background tasks.

Also note that using an anonymous thread makes it very difficult to interrupt the function when you need to stop it, e.g. when your app quits. So it's up to you to deal with situations where the function may fail to stop in time.

Parameters

  priority | The priority the thread is started with.
  functionToRun | The lambda to be called from the new Thread.

Returns
  true if the thread started successfully, or false if it failed.

## ◆ isThreadRunning()

bool Thread::isThreadRunning | ( |  | ) | const

Returns true if the thread is currently active.

## ◆ signalThreadShouldExit()

void Thread::signalThreadShouldExit | ( |  | ) |

Sets a flag to tell the thread it should stop.

Calling this means that the threadShouldExit() method will then return true. The thread should be regularly checking this to see whether it should exit.

If your thread makes use of wait(), you might want to call notify() after calling this method, to interrupt any waits that might be in progress, and allow it to reach a point where it can exit.

See also
  threadShouldExit, waitForThreadToExit

## ◆ threadShouldExit()

bool Thread::threadShouldExit | ( |  | ) | const

Checks whether the thread has been told to stop running.

Threads need to check this regularly, and if it returns true, they should return from their run() method at the first possible opportunity.

See also
  signalThreadShouldExit, currentThreadShouldExit

## ◆ currentThreadShouldExit()

static bool Thread::currentThreadShouldExit | ( |  | ) |
| static

Checks whether the current thread has been told to stop running.

On the message thread, this will always return false, otherwise it will return threadShouldExit() called on the current thread.

See also
  threadShouldExit

## ◆ waitForThreadToExit()

bool Thread::waitForThreadToExit | ( | int | timeOutMilliseconds | ) | const

Waits for the thread to stop.

This will wait until isThreadRunning() is false or until a timeout expires.

Parameters

  timeOutMilliseconds | the time to wait, in milliseconds. If this value is less than zero, it will wait forever.

Returns
  true if the thread exits, or false if the timeout expires first.

## ◆ addListener()

void Thread::addListener | ( | Listener * |  | ) |

Add a listener to this thread which will receive a callback when signalThreadShouldExit was called on this thread.

See also
  signalThreadShouldExit, removeListener

## ◆ removeListener()

void Thread::removeListener | ( | Listener * |  | ) |

Removes a listener added with addListener.

## ◆ isRealtime()

bool Thread::isRealtime | ( |  | ) | const

Returns true if this Thread represents a realtime thread.

## ◆ setAffinityMask()

void Thread::setAffinityMask | ( | uint32 | affinityMask | ) |

Sets the affinity mask for the thread.

This will only have an effect next time the thread is started - i.e. if the thread is already running when called, it'll have no effect.

See also
  setCurrentThreadAffinityMask

## ◆ setCurrentThreadAffinityMask()

static void JUCE_CALLTYPE Thread::setCurrentThreadAffinityMask | ( | uint32 | affinityMask | ) |
| static

Changes the affinity mask for the caller thread.

This will change the affinity mask for the thread that calls this static method.

See also
  setAffinityMask

## ◆ sleep()

static void JUCE_CALLTYPE Thread::sleep | ( | int | milliseconds | ) |
| static

Suspends the execution of the current thread until the specified timeout period has elapsed (note that this may not be exact).

The timeout period must not be negative and whilst sleeping the thread cannot be woken up so it should only be used for short periods of time and when other methods such as using a WaitableEvent or CriticalSection are not possible.

## ◆ yield()

static void JUCE_CALLTYPE Thread::yield | ( |  | ) |
| static

Yields the current thread's CPU time-slot and allows a new thread to run.

If there are no other threads of equal or higher priority currently running then this will return immediately and the current thread will continue to run.

## ◆ wait()

bool Thread::wait | ( | double | timeOutMilliseconds | ) | const

Suspends the execution of this thread until either the specified timeout period has elapsed, or another thread calls the notify() method to wake it up.

A negative timeout value means that the method will wait indefinitely.

Returns
  true if the event has been signalled, false if the timeout expires.

## ◆ notify()

void Thread::notify | ( |  | ) | const

Wakes up the thread.

If the thread has called the wait() method, this will wake it up.

See also
  wait

## ◆ getCurrentThreadId()

static ThreadID JUCE_CALLTYPE Thread::getCurrentThreadId | ( |  | ) |
| static

Returns an id that identifies the caller thread.

To find the ID of a particular thread object, use getThreadId().

Returns
  a unique identifier that identifies the calling thread.

See also
  getThreadId

Referenced by ThreadLocalValue< Type >::get(), and ThreadLocalValue< Type >::releaseCurrentThreadStorage().

## ◆ getCurrentThread()

static Thread *JUCE_CALLTYPE Thread::getCurrentThread | ( |  | ) |
| static

Finds the thread object that is currently running.

Note that the main UI thread (or other non-JUCE threads) don't have a Thread object associated with them, so this will return nullptr.

## ◆ getThreadId()

ThreadID Thread::getThreadId | ( |  | ) | const
| noexcept

Returns the ID of this thread.

That means the ID of this thread object - not of the thread that's calling the method. This can change when the thread is started and stopped, and will be invalid if the thread's not actually running.

See also
  getCurrentThreadId

## ◆ getThreadName()

const String & Thread::getThreadName | ( |  | ) | const
| noexcept

Returns the name of the thread.

This is the name that gets set in the constructor.

## ◆ setCurrentThreadName()

static void JUCE_CALLTYPE Thread::setCurrentThreadName | ( | const String & | newThreadName | ) |
| static

Changes the name of the caller thread.

Different OSes may place different length or content limits on this name.

## ◆ initialiseJUCE()

static void Thread::initialiseJUCE | ( | void * | jniEnv,
|  | void * | jContext
| ) |  |
| static

Initialises the JUCE subsystem for projects not created by the Projucer.

On Android, JUCE needs to be initialised once before it is used. The Projucer will automatically generate the necessary java code to do this. However, if you are using JUCE without the Projucer or are creating a library made with JUCE intended for use in non-JUCE apks, then you must call this method manually once on apk startup.

You can call this method from C++ or directly from java by calling the following java method:

com.rmsl.juce.Java.initialiseJUCE (myContext);

Note that the above java method is only available in Android Studio projects created by the Projucer. If you need to call this from another type of project then you need to add the following java file to your project:

package com.rmsl.juce;
public class Java
{
static { System.loadLibrary ("juce_jni"); }
public native static void initialiseJUCE (Context context);
}

Parameters

  jniEnv | this is a pointer to JNI's JNIEnv variable. Any callback from Java into C++ will have this passed in as it's first parameter.
  jContext | this is a jobject referring to your app/service/receiver/ provider's Context. JUCE needs this for many of it's internal functions.

## ◆ getPriority()

Priority Thread::getPriority | ( |  | ) | const
| protected

Returns the current priority of this thread.

This can only be called from the target thread. Doing so from another thread will cause an assert.

See also
  setPriority

## ◆ setPriority()

bool Thread::setPriority | ( | Priority | newPriority | ) |
| protected

Attempts to set the priority for this thread.

Returns true if the new priority was set successfully, false if not.

This can only be called from the target thread. Doing so from another thread will cause an assert.

Parameters

  newPriority | The new priority to be applied to the thread. Note: This has no effect on Linux platforms, subsequent calls to 'getPriority' will return this value.

See also
  Priority

## Member Data Documentation

## ◆ osDefaultStackSize

constexpr size_t Thread::osDefaultStackSize { 0 }
| staticconstexpr

The documentation for this class was generated from the following file:

- juce_Thread.h